> ## Documentation Index
> Fetch the complete documentation index at: https://www.cometchat.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Multi Tab Chat UI Guide

> Multi Tab Chat UI Guide — CometChat integration guide.

This guide will help you achieve a tabbed layout (aka Multi-Tab Chat UI) of the components available in CometChatUIKit for React.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/8ODUflBxloB1jkgP/images/03197ab6-multi_tab_ui_web_screens-c0c7fa04e1f6e07da1e72c039f1b3e64.png?fit=max&auto=format&n=8ODUflBxloB1jkgP&q=85&s=c9da5f46a1edd76ad08841f5459051a4" width="3600" height="2400" data-path="images/03197ab6-multi_tab_ui_web_screens-c0c7fa04e1f6e07da1e72c039f1b3e64.png" />
</Frame>

We’ll use the [CometChatConversationsWithMessages](/ui-kit/react/v4/conversations-with-messages), [CometChatUsersWithMessages](/ui-kit/react/v4/users-with-messages), and [CometChatGroupsWithMessages](/ui-kit/react/v4/groups-with-messages) components and launch them as individual tab items within the tabbed layout.

Step 1: Create a new component CometChatUI

<Tabs>
  <Tab title="CometChatUI.tsx">
    ```typescript theme={null}
    export function CometChatUI() {

    	return (
    	    <div style={{ width: "100%", height: "100%" }}><div>
    	);
    }
    ```
  </Tab>
</Tabs>

Step 2: Import the CometChatTabs component from the UI Kit.

<Tabs>
  <Tab title="CometChatUI.tsx">
    ```typescript theme={null}
    import { CometChatTabs } from "@cometchat/chat-uikit-react";

    export function CometChatUI() {
      return (
          <div style={{ width: "100%", height: "100%" }}>
            <CometChatTabs
              tabAlignment={TabAlignment.bottom}
              tabs={tabs}
              tabsStyle={tStyle}
            />
          </div>
      );
    }
    ```
  </Tab>
</Tabs>

Step 3: Pass [CometChatConversationsWithMessages](/ui-kit/react/v4/conversations-with-messages), [CometChatUsersWithMessages](/ui-kit/react/v4/users-with-messages), [CometChatGroupsWithMessages](/ui-kit/react/v4/groups-with-messages) components to the Tabs components to launch them as individual tab item.

<Tabs>
  <Tab title="CometChatUI.tsx">
    ```typescript theme={null}
    import { React, useEffect, useState } from "react";
    import { TabAlignment, CometChatTabItem } from "@cometchat/uikit-resources";
    import {
      CometChatUsersWithMessages,
      CometChatGroupsWithMessages,
      CometChatConversationsWithMessages,
      CometChatTabs,
    } from "@cometchat/chat-uikit-react";

    import usersTabIcon from "./assets/users.svg";
    import groupsTabIcon from "./assets/groups.svg";
    import chatsTabIcon from "./assets/chats.svg";

    export function CometChatUI() {
      const chatsTab = new CometChatTabItem({
        id: "chats",
        iconURL: chatsTabIcon,
        title: "Chats",
        childView: <CometChatConversationsWithMessages />,
      });

      const usersTab = new CometChatTabItem({
        id: "users",
        iconURL: usersTabIcon,
        title: "Users",
        childView: <CometChatUsersWithMessages />,
      });

      const groupsTab = new CometChatTabItem({
        id: "groups",
        title: "Groups",
        iconURL: groupsTabIcon,
        childView: <CometChatGroupsWithMessages />,
      });

      const tabs = [chatsTab, usersTab, groupsTab];

      return (
          <div style={{ width: "100%", height: "100%" }}>
            <CometChatTabs
              tabAlignment={TabAlignment.bottom}
              tabs={tabs}
              tabsStyle={tStyle}
            />
          </div>
      );
    }
    ```
  </Tab>
</Tabs>

Step 4: We make the Chats tab the active tab by default. Apply styles to all the tab items, as well as the entire tabs component, and align them to the bottom of the container. The tab items are draggable so that the user is able to drag and drop them within the container.

<Tabs>
  <Tab title="CometChatUI.tsx">
    ```typescript theme={null}
    import { BaseStyle, TabItemStyle } from "@cometchat/uikit-shared";
    import {
        CometChatConversationsWithMessages,
        CometChatGroupsWithMessages,
        CometChatTabs,
        CometChatUsersWithMessages,
        TabsStyle
    } from "@cometchat/chat-uikit-react";
    import { CometChatTabItem, TabAlignment } from "@cometchat/uikit-resources";
    import { useEffect, useState } from "react";
    import usersTabIcon from "./assets/users.svg";
    import groupsTabIcon from "./assets/groups.svg";
    import chatsTabIcon from "./assets/chats.svg";
    export function CometChatUI() {
        const [isMobileView, setIsMobileView] = useState(false);
        const tabItemStyle = new TabItemStyle({
          iconTint: "#6851D6",
          width: "93px",
          height: "auto",
          activeTitleTextColor: "#6851D6",
          background:'#fff',
          activeIconTint:'#6851D6',
        });
        const tStyle = new TabsStyle({
            tabListHeight: "50px",
            tabListWidth: "280px",
            });
        const chatsTab = new CometChatTabItem({
          id: "chats",
          title: "Chats",
          iconURL: chatsTabIcon,
          style: tabItemStyle,
          isActive: true,
          childView: (
            <CometChatConversationsWithMessages isMobileView={isMobileView} />
          ),
        });
        const usersTab = new CometChatTabItem({
          id: "users",
          title: "Users",
          iconURL: usersTabIcon,
          style: tabItemStyle,
          childView: <CometChatUsersWithMessages />,
        });
        const groupsTab = new CometChatTabItem({
          id: "groups",
          title: "Groups",
          iconURL: groupsTabIcon,
          style: tabItemStyle,
          childView: <CometChatGroupsWithMessages isMobileView={isMobileView} />,
        });
        const tabs = [chatsTab, usersTab, groupsTab];
        const resizeWindow = () => {
          const innerWidth = window.innerWidth;
          if (innerWidth >= 320 && innerWidth <= 767) {
            setIsMobileView(true);
          } else {
            setIsMobileView(false);
          }
        };
        useEffect(() => {
          resizeWindow();
          window.addEventListener("resize", resizeWindow);
          return () => window.removeEventListener("resize", resizeWindow);
        }, []);
        return (
          <div style={{ width: "100%", height: "100%" }}>
            <CometChatTabs
              tabAlignment={TabAlignment.bottom}
              tabs={tabs}
              tabsStyle={tStyle}
            />
          </div>
        );
      }
    ```
  </Tab>
</Tabs>

Step 5: Import the CometChatUI component into your App component.

<Tabs>
  <Tab title="App.jsx">
    ```javascript theme={null}
    import logo from "./logo.svg";
    import "./App.css";
    import { CometChatUI } from "./CometChatUI";

    function App(props) {
      return (
        <div className="App">
          <CometChatUI />
        </div>
      );
    }

    export default App;
    ```
  </Tab>

  <Tab title="index.jsx">
    ```javascript theme={null}
    import React from 'react';
    import ReactDOM from 'react-dom/client';
    import './index.css';
    import App from './App';
    import { UIKitSettingsBuilder } from '@cometchat/uikit-shared';
    import { CometChatUIKit } from '@cometchat/chat-uikit-react';

    const urlParams = new URLSearchParams(window.location.search);

    const appID = "APP_ID";
    const region = "REGION";
    const authKey = "AUTH_KEY";
    const uid = urlParams.get('uid') || "cometchat-uid-1";

    const uiKitSettings = new UIKitSettingsBuilder()
    .setAppId(appID)
    .setRegion(region)
    .setAuthKey(authKey)
    .subscribePresenceForFriends()
    .build();

    CometChatUIKit.init(uiKitSettings)?.then((response) => {
      console.log('CometChatUIKit initialization completed successfully');

      CometChatUIKit.login(uid)?.then(user => {
        console.log('CometChatUIKit login completed successfully');
        const root = ReactDOM.createRoot(document.getElementById('root') as HTMLElement);
        root.render(<App />);

      });

    });
    ```
  </Tab>
</Tabs>

You can now see chats, users and group components each as tab items. This is how you can launch CometChat UIKit’s individual component in a tabbed layout. 🎉

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/vk8kXY4T6hhH4l00/images/6a875a63-wm2swjlupe5cqqit0xzdw5r4gydv4bkt46lve90x91td1k7k3efognoyr1dig5t7-740e82849e7c625d511101a424f0501f.png?fit=max&auto=format&n=vk8kXY4T6hhH4l00&q=85&s=4f3217ab4cca9997eaacb49bd04e058e" width="1620" height="1014" data-path="images/6a875a63-wm2swjlupe5cqqit0xzdw5r4gydv4bkt46lve90x91td1k7k3efognoyr1dig5t7-740e82849e7c625d511101a424f0501f.png" />
</Frame>


> ## Documentation Index
> Fetch the complete documentation index at: https://www.cometchat.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Multi Tab Chat UI Guide

> Multi Tab Chat UI Guide — CometChat integration guide.

This guide will help you achieve a tabbed layout (aka Multi-Tab Chat UI) of the components available in CometChatUIKit for Angular.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/iII-209mTdOytBSH/images/f01f9f26-multi_tab_ui_web_screens-6e55dde4a0c3a2ccdd51a6a3ecf10627.png?fit=max&auto=format&n=iII-209mTdOytBSH&q=85&s=4a7d60220741245d66bcd46c55a3d197" width="3600" height="2400" data-path="images/f01f9f26-multi_tab_ui_web_screens-6e55dde4a0c3a2ccdd51a6a3ecf10627.png" />
</Frame>

We’ll use the [CometChatConversationsWithMessages](/docs/ui-kit/angular/v4/conversations-with-messages), [CometChatUsersWithMessages](/docs/ui-kit/angular/v4/users-with-messages), and [CometChatGroupsWithMessages](/docs/ui-kit/angular/v4/groups-with-messages) components and launch them as individual tab items within the tabbed layout.

<Note>
  We recommend that you read the [Key Concepts](/docs/fundamentals/key-concepts) , follow the guidelines, and also take the time to familiarise yourself with the library's [components](/docs/ui-kit/angular/v4/components-overview).
</Note>

Step 1: Create a new component CometChatUI

<Tabs>
  <Tab title="cometchat-ui.component.ts">
    ```ts theme={null}
    import { Component, HostListener, OnInit, TemplateRef, ViewChild } from '@angular/core';
    import { CometChatTabItem } from '@cometchat/chat-uikit-angular';

    @Component({
      selector: 'app-cometchat-ui',
      templateUrl: './cometchat-ui.component.html',
      styleUrls: ['./cometchat-ui.component.scss']
    });

    export class CometchatUiComponent implements OnInit {


    }
    ```
  </Tab>
</Tabs>

Step 2: Include the Tabs component from the UI Kit and include the ConversationsWithMessages, UsersWithMessages, GroupsWithMessages components. We'll also apply some styling to the tab items.

<Tabs>
  <Tab title="cometchat-ui.component.ts">
    ```ts theme={null}
    import {
      Component,
      HostListener,
      OnInit,
      TemplateRef,
      ViewChild,
    } from "@angular/core";
    import { BaseStyle } from "@cometchat/uikit-elements";
    import { TabItemStyle } from "@cometchat/uikit-shared";
    import { CometChatTabItem } from "@cometchat/chat-uikit-angular";

    export class CometchatUiComponent implements OnInit {
      //access the refs using view child
      @ViewChild("chatsRef", { static: false }) chatsRef!: TemplateRef<any>;
      @ViewChild("usersRef", { static: false }) usersRef!: TemplateRef<any>;
      @ViewChild("groupsRef", { static: false }) groupsRef!: TemplateRef<any>;

      public tabsStyle: BaseStyle = {
        border: "1px solid grey",
      };
      public tabs!: CometChatTabItem[]; //array of tabs item

      //Styling tab items
      public tabItemStyle: TabItemStyle = new TabItemStyle({
        height: "fit-content",
        width: "67px",
        background: "white",
        activeBackground: "white",
        titleTextColor: "RGBA(20, 20, 20, 0.46)",
        titleTextFont: "400 13px Inter",
        iconTint: "RGBA(20, 20, 20, 0.46)",
        activeIconTint: "RGB(51, 153, 255)",
        activeTitleTextColor: "RGB(51, 153, 255)",
        activeTitleTextFont: "RGB(51, 153, 255)",
      });

      //create an array of tabs item
      ngAfterViewInit() {
        setTimeout(() => {
          this.tabs = [
            {
              childView: this.chatsRef,
              title: "chats",
              id: "chats",
              iconURL: "assets/chats.svg",
              style: this.tabItemStyle,
            },
            {
              childView: this.usersRef,
              title: "users",
              id: "users",
              iconURL: "assets/user.svg",
              style: this.tabItemStyle,
            },
            {
              childView: this.groupsRef,
              title: "groups",
              iconURL: "assets/group.svg",
              id: "groups",
              style: this.tabItemStyle,
            },
          ];
        }, 0);
      }
    }
    ```
  </Tab>

  <Tab title="cometchat-ui.component.html">
    ```html theme={null}
    <cometchat-tabs [tabs]="tabs" [tabsStyle]="tabsStyle"></cometchat-tabs>

    <ng-template #chatsRef>
      <cometchat-conversations-with-messages
        [isMobileView]="isMobileView"
      ></cometchat-conversations-with-messages>
    </ng-template>

    <ng-template #usersRef>
      <cometchat-users-with-messages
        [isMobileView]="isMobileView"
      ></cometchat-users-with-messages>
    </ng-template>

    <ng-template #groupsRef>
      <cometchat-groups-with-messages
        [isMobileView]="isMobileView"
      ></cometchat-groups-with-messages>
    </ng-template>
    ```
  </Tab>
</Tabs>

Step 3: We'll now set the isMobileView prop to true/false when the window resizes, so that the components will change to a mobile or desktop view accordingly.

<Tabs>
  <Tab title="cometchat-ui.component.ts">
    ```ts theme={null}
    import { Component, HostListener, OnInit, TemplateRef, ViewChild } from '@angular/core';
    import { BaseStyle } from '@cometchat/uikit-elements';
    import { TabItemStyle } from '@cometchat/uikit-shared';
    import { CometChatTabItem } from '@cometchat/chat-uikit-angular';

    export class CometchatUiComponent implements OnInit {

      public innerWidth!: number;
      public isMobileView!: boolean;

    	//access the refs using view child
    	@ViewChild("chatsRef", { static: false }) chatsRef!: TemplateRef<any> ;
    	@ViewChild("usersRef", { static: false }) usersRef!: TemplateRef<any>;
    	@ViewChild("groupsRef", { static: false }) groupsRef!: TemplateRef<any>;

    	public tabs!:CometChatTabItem[]; //array of tabs item

      //Styling tab items
      public tabItemStyle:TabItemStyle = new TabItemStyle({
        height: "fit-content",
        width: "67px",
        background: "white",
        activeBackground: "white",
        titleTextColor: "RGBA(20, 20, 20, 0.46)",
        titleTextFont: "400 13px Inter",
        iconTint: "RGBA(20, 20, 20, 0.46)",
        activeIconTint: "RGB(51, 153, 255)",
        activeTitleTextColor: "RGB(51, 153, 255)",
        activeTitleTextFont: "RGB(51, 153, 255)",
      });

    	//updating mobile view and desktop view
    	ngOnInit(): void {
    		this.onResize();
    	}

      //create an array of tabs item
      ngAfterViewInit() {
        setTimeout(() => {
           this.tabs = [
             {
               childView:this.chatsRef,
               title:"chats",
               id:"chats",
               iconURL:"assets/chats.svg",
               style:this.tabItemStyle
             },
             {
               childView:this.usersRef,
               title:"users",
               id:"users",
               iconURL:"assets/user.svg",
               style:this.tabItemStyle
             },
             {
             childView:this.groupsRef,
             title:"groups",
             iconURL:"assets/group.svg",
             id:"groups",
             style:this.tabItemStyle
             }
           ]
         },0);

       }

    	//host listener fo
     	@HostListener("window:resize", []);
    	onResize(): void {
        try {
        	this.innerWidth = window.innerWidth;
        if (
        (this.innerWidth as any) >=  "320" &&
        (this.innerWidth as any) <=  "767"
        ) {
        	this.isMobileView = true
        } else {
        	this.isMobileView = false
        }
        } catch (error) {}
    	}

    }
    ```
  </Tab>
</Tabs>

Step 4: Import the CometChatUI component into your App component.

<Tabs>
  <Tab title="app.module.ts">
    ```ts theme={null}
    import { CUSTOM_ELEMENTS_SCHEMA, NgModule } from "@angular/core";
    import { BrowserModule } from "@angular/platform-browser";
    import {
      CometChatConversationsWithMessages,
      CometChatGroupsWithMessages,
      CometChatUsersWithMessages,
    } from "@cometchat/chat-uikit-angular";

    @NgModule({
      declarations: [AppComponent, CometchatUiComponent],
      imports: [
        BrowserModule,
        CometChatTabs,
        CometChatConversationsWithMessages,
        CometChatGroupsWithMessages,
        CometChatUsersWithMessages,
      ],
      providers: [],
      bootstrap: [AppComponent],
      schemas: [CUSTOM_ELEMENTS_SCHEMA],
    })
    export class AppModule {}
    ```
  </Tab>
</Tabs>

You can now see chats, users and group components each as tab items. This is how you can launch CometChat UIKit’s individual component in a tabbed layout. 🎉

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/vk8kXY4T6hhH4l00/images/6a875a63-wm2swjlupe5cqqit0xzdw5r4gydv4bkt46lve90x91td1k7k3efognoyr1dig5t7-740e82849e7c625d511101a424f0501f.png?fit=max&auto=format&n=vk8kXY4T6hhH4l00&q=85&s=4f3217ab4cca9997eaacb49bd04e058e" width="1620" height="1014" data-path="images/6a875a63-wm2swjlupe5cqqit0xzdw5r4gydv4bkt46lve90x91td1k7k3efognoyr1dig5t7-740e82849e7c625d511101a424f0501f.png" />
</Frame>
